Unit ZP17R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTZP10_p, ZP16R_p;

procedure ZP17R(var A :Array of Real; var NREAL :Integer;
                var ROOT :Array of Real; var IERR :Integer);

implementation

procedure ZP17R(var A :Array of Real; var NREAL :Integer;
                var ROOT :Array of Real; var IERR :Integer);
var
N,I,IERR1,J :Integer;
AA,ALPHA,BB,BETA,CC,DD,DELTA,R,R1,RO,X1,XN,XM,XND,XMD,GAMMA :Real;
B :Array [0..4] of Real;
D :Array [0..3] of Real;
ROOT1 :Array [0..2] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35;
begin
IERR := 0;
NREAL := 0;
for I:=1 to 2 do
 begin
  R := A[I-1];
  J := 6-I;
  A[I-1] := A[J-1];
  A[J-1] := R;
_1:
 end;
if ( A[4] <> 0.0 ) 
 then goto _2;
IERR := 65;
UTZP10(IERR,17);
goto _35;
_2:
B[0] := 1.0;
B[1] := A[3]/A[4];
B[2] := A[2]/A[4];
B[3] := A[1]/A[4];
B[4] := A[0]/A[4];
D[3] := 1.0;
D[2] := -B[2];
D[1] := B[1]*B[3]-4.0*B[4];
D[0] := B[4]*(4.0*B[2]-B[1]*B[1])-B[3]*B[3];
R1 := D[0];
D[0] := D[3];
D[3] := R1;
R1 := D[1];
D[1] := D[2];
D[2] := R1;
ZP16R(D,N,ROOT1,IERR1);
if ( N-1 ) < 0
 then goto _4
 else if ( N-1 ) > 0
       then goto _3
       else goto _4;
_3:
ROOT1[0] := ROOT1[2];
_4:
X1 := B[1]*B[1]*0.25-B[2]+ROOT1[0];
if ( X1 ) < 0
 then goto _29
 else if ( X1 ) > 0
       then goto _6
       else goto _5;
_5:
XM := 0.0;
XN := Sqrt(0.25*ROOT1[0]*ROOT1[0]-B[4]);
goto _7;
_6:
XM := Sqrt(X1);
XN := (B[1]*ROOT1[0]-2.0*B[3])*0.25/XM;
_7:
ALPHA := 0.5*B[1]*B[1]-ROOT1[0]-B[2];
BETA := 4.0*XN-B[1]*XM;
GAMMA := ALPHA+BETA;
DELTA := ALPHA-BETA;
AA := -0.5*B[1];
J := 1;
if ( GAMMA ) < 0
 then goto _9
 else if ( GAMMA ) > 0
       then goto _8
       else goto _8;
_8:
NREAL := NREAL+2;
J := 0;
GAMMA := Sqrt(GAMMA);
goto _10;
_9:
GAMMA := Sqrt(-GAMMA);
_10:
if ( DELTA ) < 0
 then goto _12
 else if ( DELTA ) > 0
       then goto _11
       else goto _11;
_11:
NREAL := NREAL+2;
DELTA := Sqrt(DELTA);
goto _13;
_12:
DELTA := Sqrt(-DELTA);
_13:
J := NREAL+J;
case J of
 1: goto _14;
 2: goto _16;
 3: goto _17;
 4: goto _18;
end;
ROOT[1] := 0.5*GAMMA;
_14:
ROOT[0] := (AA+XM)*0.5;
_15:
ROOT[2] := (AA-XM)*0.5;
ROOT[3] := 0.5*DELTA;
goto _33;
_16:
ROOT[1] := (AA+XM+GAMMA)*0.5;
ROOT[0] := (AA+XM-GAMMA)*0.5;
goto _15;
_17:
ROOT[1] := (AA-XM+DELTA)*0.5;
ROOT[0] := (AA-XM-DELTA)*0.5;
ROOT[2] := (AA+XM)*0.5;
ROOT[3] := 0.5*GAMMA;
goto _33;
_18:
BB := (AA+XM+GAMMA)*0.5;
DD := (AA-XM+DELTA)*0.5;
CC := (AA-XM-DELTA)*0.5;
AA := (AA+XM-GAMMA)*0.5;
if ( AA-CC ) < 0
 then goto _19
 else if ( AA-CC ) > 0
       then goto _26
       else goto _19;
_19:
ROOT[0] := AA;
if ( CC-BB ) < 0
 then goto _20
 else if ( CC-BB ) > 0
       then goto _25
       else goto _20;
_20:
ROOT[1] := CC;
if ( BB-DD ) < 0
 then goto _21
 else if ( BB-DD ) > 0
       then goto _23
       else goto _21;
_21:
ROOT[2] := BB;
_22:
ROOT[3] := DD;
goto _33;
_23:
ROOT[2] := DD;
_24:
ROOT[3] := BB;
goto _33;
_25:
ROOT[1] := BB;
ROOT[2] := CC;
goto _22;
_26:
ROOT[0] := CC;
if ( DD-AA ) < 0
 then goto _27
 else if ( DD-AA ) > 0
       then goto _28
       else goto _27;
_27:
ROOT[1] := DD;
ROOT[2] := AA;
goto _24;
_28:
ROOT[1] := AA;
if ( DD-BB ) < 0
 then goto _23
 else if ( DD-BB ) > 0
       then goto _21
       else goto _23;
_29:
XMD := Sqrt(-X1);
XND := (2.0*B[3]-B[1]*ROOT1[0])*0.25/XMD;
ALPHA := 0.5*B[1]*B[1]-ROOT1[0]-B[2];
BETA := 4.0*XND-B[1]*XMD;
RO := Sqrt(ALPHA*ALPHA+BETA*BETA);
GAMMA := Sqrt(0.5*(ALPHA+RO));
if ( GAMMA ) < 0
 then goto _31
 else if ( GAMMA ) > 0
       then goto _31
       else goto _30;
_30:
DELTA := Sqrt(-ALPHA);
goto _32;
_31:
DELTA := BETA*0.5/GAMMA;
_32:
ROOT[0] := 0.5*(-0.5*B[1]+GAMMA);
ROOT[1] := 0.5*(XMD+DELTA);
ROOT[2] := 0.5*(-0.5*B[1]-GAMMA);
ROOT[3] := 0.5*(XMD-DELTA);
_33:
for I:=1 to 2 do
 begin
  R := A[I-1];
  J := 6-I;
  A[I-1] := A[J-1];
  A[J-1] := R;
_34:
 end;
_35:
end;

end.
